(%--------------------------------------------------------------------------%)
(%                  Copyright (c) Donald Syme 1992                          %)
(%                  All rights reserved                                     %)
(%                                                                          %)
(% Donald Syme, hereafter referred to as `the Author', retains the copyright%)
(% and all other legal rights to the Software contained in this file,       %)
(% hereafter referred to as `the Software'.                                 %)
(%                                                                          %)
(% The Software is made available free of charge on an `as is' basis. No    %)
(% guarantee, either express or implied, of maintenance, reliability,       %)
(% merchantability or suitability for any purpose is made by the Author.    %)
(%                                                                          %)
(% The user is granted the right to make personal or internal use of the    %)
(% Software provided that both:                                             %)
(% 1. The Software is not used for commercial gain.                         %)
(% 2. The user shall not hold the Author liable for any consequences        %)
(%    arising from use of the Software.                                     %)
(%                                                                          %)
(% The user is granted the right to further distribute the Software         %)
(% provided that both:                                                      %)
(% 1. The Software and this statement of rights are not modified.           %)
(% 2. The Software does not form part or the whole of a system distributed  %)
(%    for commercial gain.                                                  %)
(%                                                                          %)
(% The user is granted the right to modify the Software for personal or     %)
(% internal use provided that all of the following conditions are observed: %)
(% 1. The user does not distribute the modified software.                   %)
(% 2. The modified software is not used for commercial gain.                %)
(% 3. The Author retains all rights to the modified software.               %)
(%                                                                          %)
(% Anyone seeking a licence to use this software for commercial purposes is %)
(% invited to contact the Author.                                           %)
(%--------------------------------------------------------------------------%)




(%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %                                                                          
 % use "hol90_replay/pp/proofs.pp.support.sml";
 % use "hol90_replay/pp/proofs.pp.sml";
 % structure PPOut = PPOutFun(ProofsPP.PP.PPBoxes);
 % val pp = PPOut.display_ppbox o ProofsPP.print_proof;
 % val p1 = ReplGoalstack.PROOF ("REWRITE_BWDTAC []",[])
 % val p2 = ReplGoalstack.PROOF ("CONJ_BWDTAC",[p1,p1]);
 % val p3 = ReplGoalstack.PROOF ("CONJ_BWDTAC",[p1]);
 % pp p1; pp p2; pp p3;
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%)

prettyprinter Proofs =

depth = infinity;

parameters 
   dummy=true; 
end parameters

rules for tac = 
   TAC(tac) -> [<h 0> tac];
end rules

rules for bwdop =
   BWDTAC(*tac) -> [<h 1> "THEN" *tac:tac];
   SINGLE_BWDTHENL(*case) -> 
          [<h 0> *case:bwdproof];
   BWDTHENL(**cases.*case) -> 
          [<v 0,0> [<h 1> "THENL ["]
                 **[<h 0> "   " *cases:bwdproof ","]
                   [<h 0> "   " *case:bwdproof]
                  "]"];
end rules

rules for bwdproof =
   BWDPROOF(BWDTAC(*hd).**ops) -> 
      [<v 0,0> *hd:tac 
             **[<h 1> *ops:bwdop]];
end rules

rules for pbwdop =
   PBWDTAC(*tac) -> [<h 1> "THEN" *tac:tac];
   SINGLE_PBWDTHENL(*case) -> 
          [<h 0> *case:pbwdproof];
   PBWDTHENL(**cases.*case) -> 
          [<v 0,0> [<h 1> "THENL ["]
                 **[<h 0> "   " *cases:pbwdproof ","]
                   [<h 0> "   " *case:pbwdproof]
                  "]"];
end rules

rules for pbwdproof =
   PBWDPROOF(PBWDTAC(*hd).**ops) -> 
      [<v 0,0> *hd:tac 
             **[<h 1> *ops:pbwdop]];
end rules

end prettyprinter       

