(*--------------------------------------------------------------------------*)
(*                  Copyright (c) Donald Syme 1992                          *)
(*                  All rights reserved                                     *)
(*                                                                          *)
(* Donald Syme, hereafter referred to as `the Author', retains the copyright*)
(* and all other legal rights to the Software contained in this file,       *)
(* hereafter referred to as `the Software'.                                 *)
(*                                                                          *)
(* The Software is made available free of charge on an `as is' basis. No    *)
(* guarantee, either express or implied, of maintenance, reliability,       *)
(* merchantability or suitability for any purpose is made by the Author.    *)
(*                                                                          *)
(* The user is granted the right to make personal or internal use of the    *)
(* Software provided that both:                                             *)
(* 1. The Software is not used for commercial gain.                         *)
(* 2. The user shall not hold the Author liable for any consequences        *)
(*    arising from use of the Software.                                     *)
(*                                                                          *)
(* The user is granted the right to further distribute the Software         *)
(* provided that both:                                                      *)
(* 1. The Software and this statement of rights are not modified.           *)
(* 2. The Software does not form part or the whole of a system distributed  *)
(*    for commercial gain.                                                  *)
(*                                                                          *)
(* The user is granted the right to modify the Software for personal or     *)
(* internal use provided that all of the following conditions are observed: *)
(* 1. The user does not distribute the modified software.                   *)
(* 2. The modified software is not used for commercial gain.                *)
(* 3. The Author retains all rights to the modified software.               *)
(*                                                                          *)
(* Anyone seeking a licence to use this software for commercial purposes is *)
(* invited to contact the Author.                                           *)
(*--------------------------------------------------------------------------*)




(*-----------------------------------------------------------------------
 * use "hol90_richtext/src/interface_maps_registry.sig"; 
 * use "hol90_richtext/src/interface_maps_registry.sml"; 
 *
 *-----------------------------------------------------------------------*)
structure InterfaceMapsRegistry : InterfaceMapsRegistry_sig = 
struct

open InterfaceMaps
val initial_map = InterfaceMaps.Sum.new ()
val interface_map_ref = ref (InterfaceMaps.Sum.restrict initial_map)
fun interface_map () = !interface_map_ref
fun main_map () = initial_map
fun set_interface_map map = (interface_map_ref := map)

val known_interface_maps_ref = ref ([]:(string * interface_map) list)
fun known_interface_maps () = !known_interface_maps_ref
fun register_interface_map s = (known_interface_maps_ref := s::(!known_interface_maps_ref))
fun find_interface_map s = assoc s (!known_interface_maps_ref)

end;

